{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X+ }

{$IFDEF DEBUG } {$R+,S+ } {$ELSE } {$D-,L-,R-,S- } {$ENDIF }

{$M $4000, 0, 655360 }

Program PCXABS;

Uses Dos,Crt;

Const INTVIDEO = $10;

Var LastVideoMode : Byte;

Procedure OpenVideo;
Var Reg : Registers;
Begin
 Reg.AH := $0F;
 Intr(INTVIDEO,Reg);
 LastVideoMode := Reg.AL;

 Reg.AH := $00;
 Reg.AL := 19;  { 320x200x256 }
 Intr(INTVIDEO,Reg);
End;


Procedure CloseVideo;
Var Reg : Registers;
Begin
 Reg.AH := $00;
 Reg.AL := LastVideoMode;
 Intr(INTVIDEO,Reg);
End;


Const LgBufMax = 1024;

      NbPlansMax = 8;

      PPLMax     = 5120;  { pixel par ligne max }


Type
     LongRec = Record
       Lo, Hi : Word;
      End;

     RGB = Record
       Red, Green, Blue : Byte;
      End;

     PCXHeadRec = Record
       Marque   : Byte;
       Version  : Byte;
       Codage   : Byte;
       BPX      : Byte;
       XG       : Word;
       YH       : Word;
       XD       : Word;
       YB       : Word;
       HRes     : Word;
       VRes     : Word;
       Palette  : Array[1..16] Of RGB;
       Reserve1 : Byte;
       NbPlans  : Byte;
       BPL      : Word;
       Reserve2 : Array[1..60] of Byte;
      End;

     Pal256 = Array[0..255] Of RGB;

     LineVideo = Array[0..PPLMax-1] Of Byte;  { jusqu' 32768 pixels/ligne ! }

     PLineVideo = ^LineVideo;

     MarkerRec = Record
       Buf    : Array[0..LgBufMax-1] Of Byte;  { buffer pour acclerer }
       LgBuf  : Word;         { nombre dans le buffer }
       iRead  : Word;         { position de lecture du buffer }
       CCode  : Byte;         { dernier code lu }
       NbRep  : Byte;         { nombre de repetition sur ce code }
      End;

     LevArray = Array[0..PPLMax-1] Of Longint;
     PLevArray= ^LevArray;

Var f         : File;         { source PCX }
    Head      : PCXHeadRec;   { en-tte }
    LgPal     : Word;         { nombre de couleurs }
(*    Pal       : Pal256;       { la palette } *)
    PalBW     : Array[0..255] Of Byte;  { pallette en noir & blanc }
    xMax      : Word;
    yMax      : Word;
    BPXMask   : Byte;
    Mark      : MarkerRec;

    gX        : Word;
    gY        : Word;
    gLg       : Word;
    gHt       : Word;

    dLg       : Word;
    dHt       : Word;

    gLine     : Word;         { n de la ligne (absolue)  lire }
    glv       : PLineVideo;
    gLev      : PLevArray;
    gResult   : PLineVideo;

    Lastglv   : PLineVideo;

    dLv       : PLineVideo;

    vir       : Longint;


Procedure Color2BW( Var p );
Var Pal : Pal256 Absolute p;
    i : Byte;
Begin
 For i := 0 To LgPal-1 Do
  Begin
   PalBW[i] := (76*Word(Pal[i].Red)) Div 255+
               (151*Word(Pal[i].Green)) Div 255+
               (28*Word(Pal[i].Blue)) Div 255;
  End;
End;

Function OpenHeader( Name : String ) : Boolean;
Var r       : Word;
    Mark    : Byte;
    i       : Byte;
    Pal     : ^Pal256;
Begin
 Assign(f,Name);
 Reset(f,1);
 If IoResult=0 Then
  Begin
   BlockRead(f,Head,sizeof(Head),r);
   If (r=SizeOf(PCXHeadRec)) And (Head.Marque=$0A) Then
    If (Head.Version>=2) Then
     If (Head.Codage=1) Then
      If (Head.BPX In [1,2,4,8]) And (Head.NbPlans In [1,2,4,8]) And
         (Head.BPX*Head.NbPlans<=8) Then
       Begin
        xMax   := (Head.XD-Head.XG)+1;
        yMax   := (Head.YB-Head.YH)+1;

        If xMax>PPLMax Then xMax := PPLMax;

        LgPal := 1 Shl (Head.BPX+Head.NbPlans-1);

        If (LgPal<256) And (LgPal In [2,4,16]) Then
         Begin
          If LgPal=2 Then
           Begin  { noir & blanc }
            PalBW[0] := 0;
            PalBW[1] := 255;
           End
          Else
           If LgPal=4 Then
            Begin
             PalBW[0] := 0;         { noir }
             PalBW[1] := 151;       { Turquoise/Vert }
             PalBW[2] := 76;        { Violet/Rouge }
             PalBW[3] := 255;       { Blanc/Jaune }
            End
           Else Color2BW(Head.Palette);

          OpenHeader := TRUE;
          Exit;
         End
        Else
         If LgPal=256 Then
          Begin { 256 couleurs !!! }
           New(Pal);
           Seek(f,FileSize(f)-(SizeOf(Pal256)+1));
           BlockRead(f,Mark,SizeOf(Mark),r);
           If (r=SizeOf(Mark)) and (Mark=$0C) then
            Begin
             BlockRead(f,Pal^,SizeOf(Pal^),r);

             If r=SizeOf(Pal^) then
              Begin
               Color2BW(Pal^);

               Dispose(Pal);

               OpenHeader := TRUE;
               Exit;
              End
             Else Writeln('Palette invalide');
            End
           Else Writeln('Palette 256 couleurs non trouve');
          End
         Else Writeln('nombre de couleurs (',LgPal,') non trait');
       End
      Else Writeln('organisation d''image non reconnu')
     Else Writeln('type de codage inconnu')
    Else Writeln('version non reconnu')
   Else Writeln('fichier PCX non reconnu');

   Close(f);

  End
 Else Writeln('Ouverture du fichier impossible');
 OpenHeader := FALSE;
End;

{ mettre la palette en noir & blanc }

Procedure Pal2BW;
Var Pal : Pal256;
    i   : Byte;
    Reg : Registers;
Begin
 { pallete grise }

 For i := 0 To 63 Do
  With Pal[i] Do
   Begin
    Red   := i;
    Green := i;
    Blue  := i;
   End;

 { red }

 For i := 64 To 64+63 Do
  With Pal[i] Do
   Begin
    Red   := i;
    Green := 0;
    Blue  := 0;
   End;

 { green }

 For i := 128 To 128+63 Do
  With Pal[i] Do
   Begin
    Red   := 0;
    Green := i;
    Blue  := 0;
   End;

 { green }

 For i := 192 To 192+63 Do
  With Pal[i] Do
   Begin
    Red   := 0;
    Green := 0;
    Blue  := i;
   End;


 Reg.AH := $10;
 Reg.AL := $12;
 Reg.BX := 0;
 Reg.CX := 256;
 Reg.ES := Seg(Pal);
 Reg.DX := Ofs(Pal);
 Intr(INTVIDEO,Reg);
End;


Function  ReadZipByte : Byte;
Begin
 If Mark.iRead>=Mark.LgBuf then
  Begin
   BlockRead(f,Mark.Buf,sizeof(Mark.Buf),Mark.LgBuf);
   Mark.iRead := 0;
  End;
 ReadZipByte := Mark.Buf[Mark.iRead];
 Inc(Mark.iRead);
End;


Function  ReadByte : Byte;
Label Ici;
Begin
 If Mark.NbRep=0 Then
  Begin
   Ici:
   Mark.CCode := ReadZipByte;
   If Mark.CCode And 192=192 Then
    Begin { repetition }
     Mark.NbRep := Mark.CCode And Not(192);
     If Mark.NbRep=0 Then Goto Ici;

     Mark.CCode := ReadZipByte;
    End
   Else Mark.NbRep := 1;
  End;
 Dec(Mark.NbRep);
 ReadByte := Mark.CCode;
End;

Procedure JumpLV;
Var nX    : Word;
    nPlan : Word;
    iCode : Byte;
Begin
 For nPlan := 1 To Head.NbPlans Do
  Begin
   iCode := 0;
   For nX := 0 To xMax-1 Do
    Begin
     If iCode=0 Then ReadByte;
     Inc(iCode,Head.BPX);
     If iCode=8 Then iCode := 0;
    End;
  End;

End;



Procedure ReadLV;
Var nX    : Word;
    nPlan : Word;
    code  : Byte;
    co    : Byte;
    nbd   : Byte;
    iCode : Byte;
    b     : Byte;
Begin
 For nX := 0 To gLg-1 Do glv^[nX] := 0;

 For nPlan := 1 To Head.NbPlans Do
  Begin
   iCode := 0;

   nX := 0;
   While nX<gX Do
    Begin
     If iCode=0 Then code := ReadByte;
     Inc(iCode,Head.BPX);
     If iCode=8 Then iCode := 0;
     Inc(nX);
    End;

   For nX := 0 To gLg-1 Do
    Begin
     If iCode=0 Then code := ReadByte;

     nbd := 8-(iCode+Head.BPX);

     b := (code Shr nbd) And BPXMask;

     glv^[nX] := glv^[nX] or (b Shl ((nPlan-1)*Head.BPX));

     Inc(iCode,Head.BPX);
     If iCode=8 Then iCode := 0;
    End;

   For nX := gX+gLg To xMax-1 Do
    Begin
     If iCode=0 Then code := ReadByte;
     Inc(iCode,Head.BPX);
     If iCode=8 Then iCode := 0;
    End;
  End;

 For nX := 0 To gLg-1 Do glv^[nX] := PalBW[glv^[nX]];

 Inc(gLine);
End;





{ prepare la lecture du fichier sur plusieurs plans, si besoin }

Procedure ReadInit;
Begin
 Seek(f,SizeOf(Head));

 FillChar(Mark,SizeOf(Mark),0);

 BPXMask  := (1 Shl (Head.BPX))-1;

 If gX>=xMax Then gX := 0;
 If gY>=yMax Then gY := 0;
 If gLg>=xMax Then gLg := xMax;
 If gHt>=yMax Then gHt := yMax;
 If gX+gLg>=xMax Then gLg := xMax-gX;
 If gY+gHt>=yMax Then gHt := yMax-gY;

 gLine := 0;

 vir := 0;

 GetMem(glv,SizeOf(glv^[0])*gLg);
 GetMem(gLev,SizeOf(gLev^[0])*gLg);
 GetMem(gResult,SizeOf(gResult^[0])*gLg);

 GetMem(dlv,SizeOf(dlv^[0])*dLg);
End;


Procedure ScaleLV( Var src : LineVideo; Var dst : LineVideo; rch : Longint );
Var ir   : Longint;
    i    : Word;
    lev  : Longint;
    lu   : Longint;
    cqr  : Longint;
Begin
 ir := 0;

 For i := 0 To dLg-1 Do
  Begin
   lev := 0;
   lu  := 0;

   Repeat

    If LongRec(ir).Lo<>0 Then cqr := 65536-LongRec(ir).Lo
    Else
     If rch<=65536 Then cqr := rch
     Else cqr := 65536;

    If lu+cqr>rch Then cqr := rch-lu;

    Inc(lev,(Longint(src[LongRec(ir).Hi]))*cqr);
    Inc(lu,cqr);
    Inc(ir,cqr);

   Until lu>=rch;

   dst[i] := lev Div lu;
  End;
End;



Procedure ScaleReadLV( rcv : Longint );
Var lu  : Longint;
    cqr : Longint;
    i   : Word;
Begin
{ ReadLV; }

 For i := 0 To gLg-1 Do gLev^[i] := 0;

 lu := 0;

 Repeat
  If LongRec(vir).Hi=gLine Then
   Begin
    ReadLV;
   End;

  If LongRec(vir).Lo<>0 Then cqr := 65536-LongRec(vir).Lo
  Else
   If rcv<=65536 Then cqr := rcv
   Else cqr := 65536;

  If lu+cqr>rcv Then cqr := rcv-lu;

  For i := 0 To gLg-1 Do
   Inc(glev^[i],(Longint(glv^[i]))*cqr);

  Inc(lu,cqr);
  Inc(vir,cqr);

 Until lu>=rcv;

 For i := 0 To gLg-1 Do
  gResult^[i] := gLev^[i] Div lu;

End;


Procedure ShowPixel( x, y : Word; color : Byte );
Var Reg : Registers;
Begin
 Reg.AH := $0C;
 Reg.BH := 0;
 Reg.DX := y;
 Reg.CX := x;
 Reg.AL := color;
 Intr(INTVIDEO,Reg);
End;

(*
Procedure ShowPixel( x, y : Word; c : Byte );
Var Ofs : word;
    rien : byte;
begin
  Ofs := (x div 8)+y*40;
  rien := mem[$A000:Ofs];    { charger les registres Latch }
  PortW[$3CE] := $0205;      { Mode Write 2 }
  PortW[$3CE] := $0003;      { mode Replace }
  PortW[$3CE] := $08+byte(1 shl ( (x mod 8) xor 7 ))*256; { Masque de bits }
  mem[$A000:Ofs] := byte(c); { ecrire couleur (point) }
end;
*)


Procedure ShowLV( Var lv : LineVideo; Line : Word );
Var i : Word;
    l : Word;
Begin
 l := 320;
 If dLg<l Then l := dLg;

 For i := 0 To l-1 Do
  Begin
   ShowPixel(i,Line-1,lv[i] Shr 2);
  End;
End;


Procedure ShowBW;
Var li : Word;
    rch : Longint;
    rcv : Longint;
    i   : Word;
Begin
 ReadInit;

 li := 0;

 While (li<gY) And Not(KeyPressed) Do
  Begin         { saute }
   JumpLV;
   Inc(li);
  End;

 rch  := (gLg*65536) Div dLg;

 rcv  := (gHt*65536) Div dHt;

 li := 0;

 While (li<dHt) And (li<200) And Not(KeyPressed) Do
  Begin
   ScaleReadLV(rcv);

   ScaleLV(gResult^,dlv^,rch);

   ShowLV(dlv^,li);
   Inc(li);
  End;

End;



Begin
 If OpenHeader(ParamStr(1)) Then
  Begin
   gX  := 0;
   gY  := 0;
   gLg := xMax;
   gHt := yMax;

(*   gX  := 100 { +50 };
   gY  := 100+100;
   gLg := 160;
   gHt := 160;
  *)
(*
   gX  := 120+100;
   gY  := 30;
   gLg := 120;
   gHt := 90;
*)
   dLg  := 320;
   dHt  := 200;

   OpenVideo;

(*   TRUEPAL; *)

   Pal2BW;

   ShowBW;
(*   RandomTrace( 0 ); *)

   Sound(1000); Delay(50); NoSound;

   Repeat Until KeyPressed;


   CloseVideo;

   Close(f);

  End;
End.
