{$A+,B-,E-,F-,N-,O-,V-,I- }

{$IFDEF DEBUG }
  {$D+,L+,R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit RamDisk2;

Interface

Type PBufRec = ^BufRec;
     BufRec = record
         Lg   : word;
         Don  : array[1..256] of byte;
         next : PBufRec;
       end;

    RamFile = Object
       Procedure Init;
       Procedure Done;
       Procedure ResetGet;
       Procedure Put( data : byte );
       Procedure Move( var p; long : word );
       Procedure Write( Txt : string );
       Function  Size : Word;
       Function  Get : Byte;
       Procedure Read( var p; lg : word; var result : word );

       Private

       First  : PBufRec;
       Last   : PBufRec;
       CrrBuf : PBufRec;
       lev    : Word;
      End;


Implementation

Procedure RamFile.ResetGet;
Begin
 CrrBuf := First;
 lev    := 0;
End;


Procedure RamFile.Init;
Begin
 New(First);        { cr le premier buffer }
 Last        := First;
 First^.lg   := 0;
 First^.next := nil;
 ResetGet;
End;


Procedure RamFile.Done;
var n : PBufRec;
begin
  while First<>nil do
    begin
      n := First^.next;
      dispose(First);
      First := n;
    end;
end;


procedure RamFile.Put( data : byte );
var b : PBufRec;
begin
  inc(Last^.lg);
  Last^.Don[Last^.lg] := data;
  if Last^.lg>=sizeof(Last^.Don) then
    begin
      new(b);
      Last^.next := b;
      Last := b;
      b^.lg := 0;
      b^.next := nil;
    end;
end;


procedure RamFile.Move( var p; long : word );
var don  : array[1..32767] of byte absolute p;
    t, i : word;
    b : PBufRec;
begin
  i := 1;
  while long>0 do
    begin
      if long>=sizeof(Last^.Don)-Last^.lg then
        t := sizeof(Last^.Don)-Last^.lg
      else t := long;
      System.move(don[i],Last^.Don[Last^.lg+1],t);
      inc(i,t);
      dec(long,t);
      inc(Last^.lg,t);
      if Last^.lg>=sizeof(Last^.Don) then
        begin
          new(b);
          Last^.next := b;
          Last := b;
          b^.lg := 0;
          b^.next := nil;
        end;
    end;
end;

procedure RamFile.Write( txt : string );
begin
  Move(txt[1],length(txt));
end;

function RamFile.Size : word;
var b : PBufRec;
    how : word;
begin
  b := First;
  how := 0;
  while b<>nil do
    begin
      inc(how,b^.lg);
      b := b^.next;
    end;
  Size := how;
end;

function RamFile.Get : byte;
begin
  if CrrBuf=nil then Get := 0
  else
    begin
      inc(lev);
      Get := CrrBuf^.Don[lev];
      if lev>=CrrBuf^.lg then
        begin
          CrrBuf := CrrBuf^.next;
          lev    := 0;
        end;
    end;
end;

procedure RamFile.Read( var p; lg : word; var result : word );
var dest : array[1..32767] of byte absolute p;
    t    : word;
    how  : word;
begin
  how := 0;
  while (lg>0) and (CrrBuf<>nil) do
    begin
      if lg>=CrrBuf^.lg-lev then t := CrrBuf^.lg-lev
      else t := lg;
      System.move(CrrBuf^.Don[lev+1],dest[how+1],t);
      inc(how,t);
      dec(lg,t);
      inc(lev,t);
      if lev>=CrrBuf^.lg then
        begin
          CrrBuf := CrrBuf^.next;
          lev    := 0;
        end;
    end;
  result := how;
end;

end.
